import {
  OrderDetailsFormat,
  cellInfoControlPanel
} from "../rescource/typescriptDefinition";
// 控制面板类
class ControlPanel {
  table: any;
  cell: any;
  instanceOfCells: any;
  constructor(Table, Cell, instanceOfCells) {
    this.table = Table;
    this.cell = Cell;
    this.instanceOfCells = instanceOfCells;
  }
  render() {
    const initialControlPanelHtmlText =
      '<div id="table-creator"><label> 列数 </label> <input id="totalCol" type="text" value="10"> <br><label> 行数 </label> <input id="totalRow" type="text" value="10"> <br><button id = "create-table"> 创建表格 </button></div><div id = "cell-info"><label>颜色 </label> <input type="text" name="color"><label> 单元Id </label> <input type="text" name="cellId"><label> 字体 </label> <input type="text" name="font"><label> 字体大小 </label> <input type="text" name="fontSize"><label> 颜色 </label> <input type="text" name="fontColor"><label> 加粗 </label> <input type="text" name="fontWeight"><label> 斜体 </label> <input type="text" name="fontStyle"><label> 下划线 </label> <input type="text" name="textDecoration"><label> 边框 </label> <input type="text" name="border"><label> 背景颜色 </label> <input type="text" name="backgroundColor"><label> 位置 </label> <input type="text" name="textAlign"><label>内容 </label> <input type="text" name="content"><button id = "update" > 更新 </button></div>';
    document.getElementById("designer").innerHTML = initialControlPanelHtmlText;
    // this.createTable(this.table, this.cell, this.instanceOfCells);
    // this.update(this.instanceOfCells, this.table);
  }
  createTable(tableInfo, Table, Cell) {
    tableInfo.splice(0, tableInfo.length);
    const rowElement = <HTMLInputElement>document.getElementById("totalRow");
    const totalRow = Number(rowElement.value);
    const colElement = <HTMLInputElement>document.getElementById("totalCol");
    const totalCol = Number(colElement.value);
    for (var i = 0; i < totalRow; i++) {
      const cells = [];
      for (var j = 0; j < totalCol; j++) {
        var letter = String.fromCharCode("A".charCodeAt(0) + j - 1);

        const newCell = new Cell(letter + i);
        cells.push(newCell);
      }
      tableInfo.push({ rowId: i, cells: cells });
    }

    new Table().render(tableInfo);

    console.log(tableInfo);
  }
  update(tableInfo, Table) {
    const cellInfoObject: cellInfoControlPanel = {
      backgroundColor: "",
      border: "",
      cellId: "",
      color: "",
      font: "",
      fontColor: "",
      fontSize: "",
      fontStyle: "",
      fontWeight: "",
      textAlign: "",
      textDecoration: ""
    };
    const cellInfoElements = document
      .getElementById("cell-info")
      .getElementsByTagName("input");
    for (let index = 0; index < cellInfoElements.length; index++) {
      cellInfoObject[cellInfoElements[index].name] =
        cellInfoElements[index].value;
    }
    for (const row of tableInfo) {
      for (const cell of row.cells) {
        if (cell.cellId === cellInfoObject.cellId) {
          for (const key in cellInfoObject) {
            cell[key] = cellInfoObject[key];
          }
        }
      }
    }
    console.log("hi");
    new Table().render(tableInfo);
  }

  setFont() {}
  setFontSize() {}
  setFontColor() {}
  setFontWeight() {}
  setTextUnderline() {}
  setTextDecoration() {}
  setBorder() {}
  setTextLineThrough() {}
  setBackgroupColor() {}
  setTextLeft() {}
  setTextCenter() {}
  setTextRight() {}
  resetTextStyle() {}
  insertTable() {}
  tablePreview() {}
  exportPdf() {}
  exportExcel() {}
}
// 数据源类
class DataResource {
  displayName: string;
  sourceName: string;
  sourceType: number;
  items: DataResourceItem[];
}

class DataResourceItem {
  displayName: string;
  dataField: string;
  constructor(name, field) {
    this.displayName = name;
    this.dataField = field;
  }
}

let orderDetailsMatches = new DataResource();
orderDetailsMatches.displayName = "订单信息";
orderDetailsMatches.sourceName = "orders";
orderDetailsMatches.sourceType = 0;
orderDetailsMatches.items = [
  new DataResourceItem("${订单号}", "orderNo"),
  new DataResourceItem("${客户名}", "clientName"),
  new DataResourceItem("${出售日期}", "soldDate"),
  new DataResourceItem("${联系名字}", "contactNo"),
  new DataResourceItem("${送货地址}", "deliveryAddress"),
  new DataResourceItem("${订单备注}", "addOn")
];

let banCaiMatches = new DataResource();
banCaiMatches.displayName = "板材头信息";
banCaiMatches.sourceName = "banCaiHead";
banCaiMatches.sourceType = 1;
banCaiMatches.items = [
  new DataResourceItem("${板材材料}", "material"),
  new DataResourceItem("${板材颜色}", "color")
];

let banCaiInfoMatches = new DataResource();
banCaiInfoMatches.displayName = "板材身信息";
banCaiInfoMatches.sourceName = "banCaiBody";
banCaiInfoMatches.sourceType = 1;
banCaiInfoMatches.items = [
  new DataResourceItem("${板材房名}", "houseName"),
  new DataResourceItem("${板材柜名}", "closetName"),
  new DataResourceItem("${板材编号}", "boardNo"),
  new DataResourceItem("${板材名}", "boardName"),
  new DataResourceItem("${板材长度}", "length"),
  new DataResourceItem("${板材宽度}", "width"),
  new DataResourceItem("${板材厚度}", "thickness"),
  new DataResourceItem("${板材数量}", "quantity"),
  new DataResourceItem("${板材面积}", "area"),
  new DataResourceItem("${板材异型}", "mutation"),
  new DataResourceItem("${板材形状}", "shape"),
  new DataResourceItem("${板材方向}", "direction"),
  new DataResourceItem("${板材条纹}", "stripe"),
  new DataResourceItem("${板材备注}", "boardAddOn")
];

export { ControlPanel };
